var WPJB = WPJB || {};

WPJB.clickandpledge = {
    
    loadOnce: function() {
        var $ = jQuery;
        
        if($(".wpjb-script-external-clickandpledge").length > 0) {
            return;
        }
   
       
    },
    
    error: function(error) {
        var field = null;
        
        switch(error.code) {
            case "invalid_cvc":
            case "incorrect_cvc":
                field = "cvc";
                break;
            case "invalid_expiry_month":
            case "invalid_expiry_year":
            case "expired_card":
                field = "expiration";
                break;
            default:
                field = "card_number";
        }
        
        return field;
    },
    
    response: function(status, response) {
        var $ = jQuery;
        var $form = $('.wpjb-payment-form');

        $form.find(".wpjb-flash-error").remove();
        $form.find(".wpjb-flash-info").remove();

        if (response.error) {
            
            var field = WPJB.clickandpledge.error(response.error);
            var form = new WPJB.form(".wpjb-payment-form");
            
            form.addError(wpjb_payment_lang.form_error);
            form.addFieldError(".wpjb-element-name-"+field, response.error.message);

            $(".wpjb-place-order-wrap .wpjb-place-order").show();
            $(".wpjb-place-order-wrap .wpjb-icon-spinner").css("visibility", "hidden");
            
            return;
        } 

       // $form.find("form").append($("<input />").attr("type", "hidden").attr("name", "stripe_token").val(response.id));
            
        WPJB.order.placeOrder(undefined, {context: WPJB.clickandpledge});
    },
    
    charge: function(response) {  
		console.log(response);
        var $ = jQuery;
        var data = {
            echo: "1",
            action: "wpjb_payment_accept",
            engine: "clickandpledge_payment",
            id: response.token_id,
            token_id: response.payment_id,
			token_amount: response.token_amount,
			token_msg: response.token_msg
        };

        $.ajax({
            url: wpjb_payment_lang.ajaxurl,
            cache: false,
            type: "POST",
            data: data,
            dataType: "json",
            success: function(response) {
				console.log(response);
                var result = $("#wpjb-checkout-success");
                
                result.find(".wpjb-clickandpledge-pending").hide();
                
                if(response.external_id) {
                    result.find(".wpjb-flash-info").removeClass("wpjb-none");
                    result.find(".wpjb-flash-info .wpjb-flash-body").html(response.message);
                } else {
                    result.find(".wpjb-flash-error").removeClass("wpjb-none");
                    result.find(".wpjb-flash-error .wpjb-flash-body").html(response.message);
                }

            }
        });
        
    },
    
    placeOrder: function(e) {
        
        e.preventDefault(); var $ = jQuery;
		var currentTime = new Date();
		var year = currentTime.getFullYear();
		var month = "0"+currentTime.getMonth() + 1;
	var vcvv = $("#clickandpledge_cvc").val();
		if($('input[name=clickandpledge_onetimeonly]:checked').val()== "clickandpledge_Recurring" ||($("#clickandpledge_onetimeonly").val() == "clickandpledge_Recurring" && $('input[name=clickandpledge_onetimeonly]:checked').val() == undefined) )
			{
				
			
			if($("#clickandpledge_nooftimes").val()=="")
			  {
				 alert("Please enter Number of installments");
				 $("#clickandpledge_nooftimes").focus();
				  return false;
			  }
				else if($("#clickandpledge_nooftimes").val()!= "" && $("#clickandpledge_nooftimes").val()<= 1){
					alert("Please enter number of installments value greater than 1");
					$("#clickandpledge_nooftimes").focus();
					return false;
				}
				else if($("#clickandpledge_nooftimes").val()!= "" && $("#clickandpledge_maxinst").val()!=""){
						if(parseInt($("#clickandpledge_nooftimes").val()) > parseInt($("#clickandpledge_maxinst").val()))
							{
								alert("Please enter number of installments between 2 to "+$("#clickandpledge_maxinst").val());
								 $("#clickandpledge_nooftimes").focus();
								 return false;
							} }
					   if($("#clickandpledge_nooftimes").val()!= "" && $("#clickandpledge_indefinite").val() != "on" && $("#recurring_select").val() == "Installment" && $("#clickandpledge_maxinst").val() == "" && $("#clickandpledge_nooftimes").val()  > 998)
							{
								alert("Please enter number of installments between 2 to 998");
								 $("#clickandpledge_nooftimes").focus();
								 return false;
							}
				else if($("#clickandpledge_nooftimes").val()!= "" && $("#clickandpledge_indefinite").val() == "on" && $("#recurring_select").val() == "Installment" && $("#clickandpledge_nooftimes").val()  > 998)
					{
						alert("Recurring type installment not allow indefinite number of payments");
								 $("#recurring_select").focus();
								 return false;
					}
					
				if($("input[name='cnp_payment_method_selection']:checked"). val()!= "CreditCard" &&
					$("input[name='cnp_payment_method_selection']:checked"). val() != "eCheck")
					{
						alert("Sorry but recurring payments are not supported with this payment method");
								 $("#clickandpledge_onetimeonly").focus();
								 return false;
					}
				   
			}
      if($('input[name=cnp_payment_method_selection]:checked').val()=="CreditCard"){
		var cardno = /^(?:3[47][0-9]{13})$/;
  
		  if($("#clickandpledge_nameOnCard").val()=="")
			  {
				  alert("Please enter Name on Card");
				  $("#clickandpledge_nameOnCard").focus();
				  return false;
			  }
		   if($("#clickandpledge_cardNumber").val()=="")
			  {
				  alert("Please enter Card Number");
				  $("#clickandpledge_cardNumber").focus();
				  return false;
			  }
		  
		  if($("#clickandpledge_cvc").val()=="")
			  {
				  alert("Please enter CVV");
				  $("#clickandpledge_cvc").focus();
				  return false;
			  }
		  
		  if($.isNumeric(vcvv) === false) {
       
           alert("Please enter Numbers only in card Verification(CVV)");
				  $("#clickandpledge_cvc").focus();
				  return false;
   			}
		   if($("#clickandpledge_cardNumber").val()!="" && $("#clickandpledge_cvc").val()!="")
			   {
				   if($("#clickandpledge_cardNumber").val().match(cardno))
					   {
						   if($("#clickandpledge_cvc").val().length <4)
							   {
								   alert("Not a valid CVV");
								    $("#clickandpledge_cvc").focus();
				 					 return false;
							   }
					   }
			  
			  }
		  
		  if($("#clickandpledge_cardExpYear").val() == year)
			  {
				 if($("#clickandpledge_cardExpMonth").val() < month)
					 {
						 alert("Please enter valid Expiration");
						 $("#clickandpledge_cardExpYear").focus(); 
						 return false;
					 }
			  }
	     }
		else if($('input[name=cnp_payment_method_selection]:checked').val()=="eCheck"){
			 if($("#clickandpledge_echeck_NameOnAccount").val()=="")
			  {
				  alert("Please enter name on account");
				  $("#clickandpledge_echeck_NameOnAccount").focus();
				  return false;
			  }
			 if($("#clickandpledge_echeck_CheckNumber").val()=="")
			  {
				  alert("Please enter check number");
				  $("#clickandpledge_echeck_CheckNumber").focus();
				  return false;
			  }
			if($("#clickandpledge_echeck_RoutingNumber").val()=="")
			  {
				  alert("Please enter routing number");
				  $("#clickandpledge_echeck_RoutingNumber").focus();
				  return false;
			  }
			if($("#clickandpledge_echeck_AccountNumber").val()=="")
			  {
				  alert("Please enter account number");
				  $("#clickandpledge_echeck_AccountNumber").focus();
				  return false;
			  }
			if($("#clickandpledge_echeck_retypeAccountNumber").val()=="")
			  {
				  alert("Please enter retype account number");
				  $("#clickandpledge_echeck_retypeAccountNumber").focus();
				  return false;
			  }
		}
       else if($('input[name=cnp_payment_method_selection]:checked').val()!="eCheck" &&
			   $('input[name=cnp_payment_method_selection]:checked').val()!="CreditCard"){
		   if($("#clickandpledge_reference_number").val()=="")
			  {
				  alert("Please enter reference number");
				  $("#clickandpledge_reference_number").focus();
				  return false;
			  }
	   }
       var $form = $('.wpjb-payment-form');
        
        $(".wpjb-place-order-wrap .wpjb-place-order").fadeOut("fast");
        $(".wpjb-place-order-wrap .wpjb-icon-spinner").css("visibility", "visible");
        
        var form = new WPJB.form(".wpjb-payment-form");
         form.clearErrors();
         WPJB.order.placeOrder(undefined, {context: WPJB.clickandpledge});
      
    },
    
    placeOrderSuccess: function(response) {
       
        var $ = jQuery;
        var charge = $.extend(response, {
            payment_id: $("#wpjb-clickandpledge-payment-id").val(),
            token_id: $("#wpjb-clickandpledge-id").val(),
			token_amount: $("#wpjb-clickandpledge-amount").val(),
			token_msg: $("#wpjb-clickandpledge-responsemsg").val()
        });
        
        WPJB.clickandpledge.charge(charge);
    }
}

jQuery(function($) {     
    $(".wpjb-place-order").unbind("click").bind("click", WPJB.clickandpledge.placeOrder);
    WPJB.clickandpledge.loadOnce();
    	jQuery('#clickandpledge_nooftimes').keypress(function(e) {
						var a = [];
						var k = e.which;

						for (i = 48; i < 58; i++)
							a.push(i);

						if (!(a.indexOf(k)>=0))
							e.preventDefault();
					});
});

